{{
  ZX81 Emulator 0.1  
  ------------------------------------------
  
  Copyright (C) 2008 Gianni Metitieri

  Special thanks to Gregory Alekel http://www.commodorestuff.com  for many idea taken from his C64 loader 

  This file is part of ZX81 Emulator.
   
  ZX81 Emulator is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 3 of the License, or
  (at your option) any later version.
   
  ZX81 Emulator is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.
   
  You should have received a copy of the GNU General Public License
  along with this program.  If not, see <http://www.gnu.org/licenses/>.
}}

CON
' *************************************************
' *       Versioning Information                   
' *************************************************
  major      = 0                ' major version
  minor      = 1                ' minor version
  build      = 0                ' build

' *************************************************
' *      User Definable Settings       
' *************************************************

  _xinfreq      = 10_000_000
  _clkmode      = xtal1 + pll8x
  _stack        = 500


VAR

  long i
  long k
  long m
  long curr_key
  long mousex
  long mousey
  long c
  byte byt

   
OBJ
  TV                  : "tv_text"      
  SRAM512K            : "HX512KSRAM_ASM_DRV_010.spin"
  key                 : "keyboard_iso_010"
  mouse               : "mouse_iso_010"

PUB Start
      
  SRAM512K.SRAM_Start_ASM_Driver(%000_11_11) 

  repeat 1000
  
  
  TV.Start(24)
  
  TV.out($00)

  TV.str(string("ZX81 ROM Loader v "))
  TV.dec(major)
  TV.str(string("."))
  TV.dec(minor)
  TV.str(string(" Build "))
  TV.dec(build)
  TV.str(string(" ",13))
   
  TV.str(string("by Gianni Metitieri",13))

  TV.str(string(" ",13)) 
    'Start the keyboard
  k := key.start(3)
  TV.str (string("Starting keyboard... "))
  if k == 0
    TV.str (string("FAIL",13))
  else
    TV.str (string("OK",13))

  m:= mouse.start(2)
  TV.str (string("Starting mouse... "))
  if m == 0
    TV.str (string("FAIL",13))
  else
    TV.str (string("OK",13))
    

  FormatMemory($0000, $FFFF)
    
  LoadZX81ROM($0000, $1FFF)
  
  CopyZX81ROM

  'DisplayMemory($0000, $0010)
   
  'VerifyMemory($0000, $0014)

    
PRI DisplayMemory(StartAddress, EndAddress) | intAddress, bytValue
  
  TV.str(string("Displaying ZX81 ROM $"))
  TV.hex(StartAddress, 4)
  TV.str(string(" to $"))
  TV.hex(EndAddress, 4)
  TV.str(string(".",13))
   
  Repeat intAddress From StartAddress To EndAddress

    bytValue := ReadByte(intAddress)
{    
    TV.str(string("$"))
    TV.hex(intAddress, 4)
    TV.str(string(": "))
    TV.hex(bytValue, 2)
    TV.str(string(" "))
 }
  Result := bytValue 
  

PRI LoadZX81ROM(StartAddress, EndAddress) | intAddress, bytValue

  TV.str(string("Initializing ZX81 ROM $"))
  TV.hex(StartAddress, 4)
  TV.str(string(" to $"))
  TV.hex(EndAddress, 4)
  TV.str(string(".",13))

  Repeat intAddress from StartAddress To EndAddress
  
    bytValue := ZX81ROM[intAddress]

    'If you want to see the data fly across the screen, uncomment these lines:
{   
    TV.str(string("$")) 
    TV.hex(intAddress, 4)
    TV.str(string(": "))
    TV.hex(bytValue, 2)
    TV.str(string(" "))
}    
    WriteByte(intAddress, bytValue)  'WriteByte(intAddress, bytValue)
    
  bytValue := 0

  TV.str(string(" ",13)) 
  VerifyMemory($0000, $1FFF)


PRI CopyZX81ROM | intAddress, bytValue

  TV.str(string("Copy the 8K ZX81 ROM into $2000 - $3FFF", 13))

  Repeat intAddress from $0000 To $1FFF
  
    bytValue := ReadByte(intAddress)
    WriteByte(intAddress + $2000, bytValue)


PRI FormatMemory (StartAddress, EndAddress)| intAddress, bytValue

  bytValue := $51 

  TV.str(string("Formatting Memory..."))
  
  Repeat intAddress From StartAddress To EndAddress
  
    WriteByte( intAddress, bytValue )
    
  bytValue := $00
       
  TV.str(string("OK", 13)) 
     
PRI VerifyMemory(StartAddress, EndAddress) | intAddress, bytValue, bytValue2
   

    TV.str(string("Verifying Memory from $"))
    TV.hex(StartAddress, 4)
    TV.str(string(" to $"))
    TV.hex(EndAddress, 4)
    TV.str(string(" ",13)) 
    Repeat intAddress from StartAddress To EndAddress  
      bytValue := ZX81ROM[intAddress]
      bytValue2 := ReadByte(intAddress)

        If bytValue <> bytValue2
          TV.str(string("ROM image differs.  Try loading it again",13))
        'Repeat

    TV.str(string("ROM image verified!",13))

  
PRI ReadByte(Address) | bytValue

  bytValue := 0
  SRAM512K.SRAM_LoadAddr64k_A ($0000)
  
  bytValue := SRAM512K.SRAM_Read64K_A ( Address )

  Result := bytValue
    

PRI WriteByte(Address,Value)


 SRAM512K.SRAM_Write64K_A( Address, Value )

     

DAT

'Load ZX81 Rom

ZX81ROM     file "ZX81.ROM"